mNegDE                  macro()                         ;
                          ld a,e                        ;
                          cpl                           ;
                          ld e,a                        ;
                          ld a,d                        ;
                          cpl                           ;
                          ld d,a                        ;
                          inc de                        ;
                          mend                          ;


BuildDiv3table          LD   HL,Div3Table
                        LD   DE,Div3Table+$100
                        LD   BC,3
                        XOR  A
Div3t1                  LD   (HL),B
                        LD   (DE),A
                        INC  A
                        CP   C
                        JR   NZ,Div3t2
                        INC  B
                        XOR  A
Div3t2                  INC  L
                        INC  E
                        JR   NZ,Div3t1
                        RET

Div3DE                  BIT  7,D
                        JR   NZ,Div3dn

Div3de                  LD   H,high Div3Table
                        LD   L,D
                        LD   D,(HL)
                        INC  H
                        LD   A,(HL)
                        LD   L,E
                        DEC  H
                        CP   1
                        JR   C,Div3D0
                        JR   Z,Div3D1
                        LD   A,170
                        ADD  A,(HL)
                        LD   E,A
                        INC  H
                        LD   A,(HL)
                        OR   A
                        RET  Z
                        INC  E
                        RET

Div3D1                  LD   A,85
                        ADD  A,(HL)
                        LD   E,A
                        INC  H
                        LD   A,(HL)
                        CP   2
                        RET  NZ
                        INC  E
                        RET

Div3D0                  LD   E,(HL)
                        RET

Div3dn                  mNegDE()
                        CALL Div3de
                        mNegDE()
                        RET

RotMS                   LD   H,C
                        LD   L,C

                        SRA  D
                        RR   E

                        LD   B,5
                        JP   RMS2

RMS1                    SRA  H
                        RR   L

RMS2                    RRA
                        JR   NC,RMS3

                        ADD  HL,DE

RMS3                    DJNZ RMS1

                        LD   A,L
                        LD   L,H
                        LD   H,C
                        RLA
                        RL   L
                        JR   NC,RMS4

                        LD   H,#FF
RMS4                    RLA
                        RL   L
                        RL   H
                        RLA
                        RL   L
                        RL   H
                        RLA
                        RET  NC

                        INC  HL
                        RET

RotML                   LD   A,5
                        EX   AF,AF'

                        XOR  A
                        LD   H,A
                        LD   L,A

                        SRA  D
                        RR   E

                        RR   C
                        JP   RML2

RML1                    EX   AF,AF'

                        SRA  H
                        RR   L

                        RRA
RML2                    SRL  B
                        JR   NC,RML3

                        ADD  A,C
                        ADC  HL,DE

RML3                    EX   AF,AF'
                        DEC  A
                        JR   NZ,RML1

                        EX   AF,AF'
                        LD   C,L
                        LD   L,H
                        LD   H,0
                        RLA
                        RL   C
                        RL   L
                        JR   NC,RML4

                        LD   H,#FF
RML4                    RLA
                        RL   C
                        RL   L
                        RL   H
                        RLA
                        RL   C
                        RL   L
                        RL   H
                        RLA
                        RET  NC
                        INC  C
                        RET  NZ
                        INC  HL
                        RET


