nStars                  equ 24                          ;

        struct                                          ;
dStarX                  ds 2                            ;
dStarY                  ds 2                            ;
dStarpScreen            ds 2                            ;
dStarBit                ds 1                            ;
lStar                   equ *                           ;
        send                                            ;

InitStars               LD   IX,tStars                  ;
                        LD   B,nStars                   ;

InitStarLp              call RandOnly_HL                ;
                        LD   (IX+dStarX),HL             ;

                        call RandOnly_HL                ;
                        LD   (IX+dStarY),HL             ;

                        LD   E,(IX+dStarX+1)            ;
                        LD   D,(IX+dStarY+1)            ;
                        CALL Point                      ;

                        LD   (IX+dStarpScreen),HL       ; Save the screen pointer and bit
                        LD   (IX+dStarBit),A            ;

                        XOR  (HL)                       ; Draw it
                        LD   (HL),A                     ;

                        ; Next

                        ld de,lStar                     ;
                        add ix,de                       ;
                        DJNZ InitStarLp                 ;

                        ret                             ;

; Move the stars

MoveStar                LD   IX,tStars                  ;
                        LD   B,nStars                   ;
                        LD   C,0                        ;

MoveStarLp              PUSH BC                         ;

                        LD   DE,(IX+dStarY)             ;
                        LD   A,(angle)                  ;
                        CALL RotMS                      ;

StarM4                  LD   DE,(IX)                    ;

                        LD   A,(angsig)                 ;
                        RRA                             ;
                        JR   C,StarM5                   ;

                        ADD  HL,DE                      ;
                        JR   StarM6                     ;

StarM5                  EX   DE,HL                      ;
                        OR   A                          ;
                        SBC  HL,DE                      ;

StarM6                  LD   (IX+dStarX),HL             ;

                        EX   DE,HL                      ;

                        LD   A,(angle)                  ;
                        CALL RotMS                      ;

StarM9                  LD   DE,(IX+dStarY)             ;

                        LD   A,(angsig)                 ;
                        RRA                             ;
                        JR   NC,StaM10                  ;

                        ADD  HL,DE                      ;
                        JR   StaM11                     ;

StaM10                  EX   DE,HL                      ;
                        OR   A                          ;
                        SBC  HL,DE                      ;

StaM11                  LD   DE,(fwdmov)                ; Add speed to Y
                        ADD  HL,DE                      ;

                        LD   (IX+dStarY),HL             ;

                        LD   D,H                        ;
                        LD   E,(IX+dStarX+1)            ;
                        CALL Point                      ;

                        LD   DE,(IX+dStarpScreen)       ;
                        LD   C,(IX+dStarBit)            ;

                        LD   B,A                        ; Draw new position
                        XOR  (HL)                       ;
                        LD   (HL),A                     ;

                        EX   DE,HL                      ; Undraw old position
                        LD   A,C                        ;
                        XOR  (HL)                       ;
                        LD   (HL),A                     ;

                        LD   (IX+dStarpScreen),DE       ; Save new position
                        LD   (IX+dStarBit),B            ;

                        LD   BC,lStar                   ; Next
                        ADD  IX,BC                      ;

                        POP  BC                         ; Loop

                        DEC  B                          ;
                        JP   NZ,MoveStarLp              ;

                        RET                             ; Done


